package rocks.zipcode.quiz5.fundamentals;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        return string.charAt((string.length()-1)/2);
    }

    public static String capitalizeMiddleCharacter(String str) {
        int middle = (str.length()-1)/2;
        return str.substring(0,middle)
                + str.substring(middle, middle+1).toUpperCase()
                + str.substring(middle+1);
    }

    public static String lowerCaseMiddleCharacter(String str) {
        int middle = (str.length()-1)/2;
        return str.substring(0,middle)
                + str.substring(middle, middle+1).toLowerCase()
                + str.substring(middle+1);
    }

    public static Boolean isIsogram(String str) {
        for (int i=0; i<str.length(); i++) {
            for (int j=i+1; j<str.length(); j++)
                if (str.charAt(i) == str.charAt(j))
                    return false;
        }
        return true;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        for (int i=0; i<str.length()-1; i++) {
            if (str.charAt(i) == str.charAt(i+1))
                return true;
        }
        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        StringBuilder sb = new StringBuilder(str.substring(0,1));
        for (int i=1; i<str.length(); i++)
            if (str.charAt(i) != str.charAt(i-1))
                sb.append(str.charAt(i));
            else sb.deleteCharAt(sb.length()-1);
        return sb.toString();
    }

    public static String invertCasing(String str) {
        StringBuilder sb = new StringBuilder();
        for (int i=0; i<str.length(); i++) {
            if (Character.isUpperCase(str.charAt(i))) sb.append(Character.toLowerCase(str.charAt(i)));
            else sb.append(Character.toUpperCase(str.charAt(i)));
        }
        return sb.toString();
    }
}